/**
 * @brief Pisca-pisca de um led azul (PTE23)
 * @author Wu Shin-Ting
 * @date 2/08/2020
 */

/**
 * @brief atraso em numero de interacoes <i>
 * @param[in] i numero de iteracoes
 */
void delay (unsigned int i)
{
	while (i) i--;
}

/**
 * @brief programa-demo da configuracao dos registradores dos modulos SIM, PORT e GPIO
 */
int main(void)
{
	// Bloco 1: Inicializar
	// Modulo SIM: habilita o clock do modulo PORTE
	(*(unsigned int volatile *) 0x40048038u) =  (*(unsigned int volatile *) 0x40048038u)| (1<<13); 
	
	// Modulo PORT: configure o pino PTE23 para GPIO (azul)
	(*(unsigned int volatile *) 0x4004D05Cu) = (*(unsigned int volatile *) 0x4004D05Cu) & 0xFFFFF8FF; // Zera bits 10, 9 e 8 (MUX) de PTE23
	(*(unsigned int volatile *) 0x4004D05Cu) = (*(unsigned int volatile *) 0x4004D05Cu) | 0x00000100; // Seta bit 8 do MUX de PTE23, assim os 3 bits de MUX serao 001 
	
	// Modulo GPIO: configure o sentido do sinal no pino PTE23
	(*(unsigned int volatile *) 0x400FF114u) = (*(unsigned int volatile *) 0x400FF114u)  | (1<<23);    // Seta pino 23 do PORTE como saida 
		
	// Bloco 2: Alternar o estado do led num laco
	for(;;) {
		//Azul
		// Escrever 1 (Set) no pino PTE23 
		(*(unsigned int volatile *) 0x400FF104u) = (1<<23); 
		delay(500000);
	 	// Escrever 0 (Clear) no pino PTE23
		(*(unsigned int volatile *) 0x400FF108u) = (1<<23);
		delay(500000);
	}
	
	return 0;
}
